--- ../../moko/android/vendor/neo/freerunner/etc/asound.conf	2009-01-22 11:21:53.000000000 +0100
+++ asound.conf	2009-01-31 17:05:24.000000000 +0100
@@ -100,25 +100,11 @@
 			{ name 'Capture Left Mux'					value PGA					}
 			{ name 'Capture Right Mixer'				value Stereo				}
 			{ name 'Capture Left Mixer'					value Stereo				}
-			{ name 'Playback Mixer Voice Capture Sw'	value false					}
-			{ name 'Playback Mixer Left Capture Swi'	value false					}
-			{ name 'Playback Mixer Right Capture Sw'	value false					}
 			{ name 'Out4 Mux'							value VREF					}
 			{ name 'Out3 Mux'							value VREF					}
 			{ name 'Mono 2 Mux'							value 'Inverted Mono 1'		}
 			{ name 'Mono Mixer Left Playback Switch'	value false					}
-			{ name 'Mono Mixer Right Playback Switc'	value false					}
-			{ name 'Mono Mixer Voice Playback Switc'	value false					}
-			{ name 'Mono Mixer Sidetone Playback Sw'	value false					}
-			{ name 'Mono Mixer Bypass Playback Swit'	value false					}
-			{ name 'Right Mixer Voice Playback Swit'	value false					}
-			{ name 'Right Mixer Sidetone Playback S'	value false					}
-			{ name 'Right Mixer Right Playback Swit'	value true					}
-			{ name 'Right Mixer Bypass Playback Swi'	value false					}
-			{ name 'Left Mixer Voice Playback Switc'	value false					}
-			{ name 'Left Mixer Sidetone Playback Sw'	value false					}
 			{ name 'Left Mixer Left Playback Switch'	value true					}
-			{ name 'Left Mixer Bypass Playback Swit'	value false					}
 			{ name 'DAPM Stereo Out Switch'				value true					}
 			{ name 'DAPM GSM Line Out Switch'			value false					}
 			{ name 'DAPM GSM Line In Switch'			value false					}
@@ -208,25 +194,11 @@
 			{ name 'Capture Left Mux'					value PGA					}
 			{ name 'Capture Right Mixer'				value Stereo				}
 			{ name 'Capture Left Mixer'					value Stereo				}
-			{ name 'Playback Mixer Voice Capture Sw'	value false					}
-			{ name 'Playback Mixer Left Capture Swi'	value false					}
-			{ name 'Playback Mixer Right Capture Sw'	value false					}
 			{ name 'Out4 Mux'							value VREF					}
 			{ name 'Out3 Mux'							value VREF					}
 			{ name 'Mono 2 Mux'							value 'Inverted Mono 1'		}
 			{ name 'Mono Mixer Left Playback Switch'	value false					}
-			{ name 'Mono Mixer Right Playback Switc'	value false					}
-			{ name 'Mono Mixer Voice Playback Switc'	value false					}
-			{ name 'Mono Mixer Sidetone Playback Sw'	value false					}
-			{ name 'Mono Mixer Bypass Playback Swit'	value false					}
-			{ name 'Right Mixer Voice Playback Swit'	value false					}
-			{ name 'Right Mixer Sidetone Playback S'	value false					}
-			{ name 'Right Mixer Right Playback Swit'	value true					}
-			{ name 'Right Mixer Bypass Playback Swi'	value false					}
-			{ name 'Left Mixer Voice Playback Switc'	value false					}
-			{ name 'Left Mixer Sidetone Playback Sw'	value false					}
 			{ name 'Left Mixer Left Playback Switch'	value true					}
-			{ name 'Left Mixer Bypass Playback Swit'	value false					}
 			{ name 'DAPM Stereo Out Switch'				value true					}
 			{ name 'DAPM GSM Line Out Switch'			value false					}
 			{ name 'DAPM GSM Line In Switch'			value false					}
@@ -316,25 +288,11 @@
 			{ name 'Capture Left Mux'					value PGA					}
 			{ name 'Capture Right Mixer'				value Stereo				}
 			{ name 'Capture Left Mixer'					value Stereo				}
-			{ name 'Playback Mixer Voice Capture Sw'	value false					}
-			{ name 'Playback Mixer Left Capture Swi'	value false					}
-			{ name 'Playback Mixer Right Capture Sw'	value false					}
 			{ name 'Out4 Mux'							value VREF					}
 			{ name 'Out3 Mux'							value VREF					}
 			{ name 'Mono 2 Mux'							value 'Inverted Mono 1'		}
 			{ name 'Mono Mixer Left Playback Switch'	value false					}
-			{ name 'Mono Mixer Right Playback Switc'	value false					}
-			{ name 'Mono Mixer Voice Playback Switc'	value false					}
-			{ name 'Mono Mixer Sidetone Playback Sw'	value false					}
-			{ name 'Mono Mixer Bypass Playback Swit'	value false					}
-			{ name 'Right Mixer Voice Playback Swit'	value false					}
-			{ name 'Right Mixer Sidetone Playback S'	value false					}
-			{ name 'Right Mixer Right Playback Swit'	value true					}
-			{ name 'Right Mixer Bypass Playback Swi'	value false					}
-			{ name 'Left Mixer Voice Playback Switc'	value false					}
-			{ name 'Left Mixer Sidetone Playback Sw'	value false					}
 			{ name 'Left Mixer Left Playback Switch'	value true					}
-			{ name 'Left Mixer Bypass Playback Swit'	value false					}
 			{ name 'DAPM Stereo Out Switch'				value true					}
 			{ name 'DAPM GSM Line Out Switch'			value false					}
 			{ name 'DAPM GSM Line In Switch'			value false					}
@@ -427,25 +385,11 @@
 			{ name 'Capture Left Mux'					value PGA					}
 			{ name 'Capture Right Mixer'				value Stereo				}
 			{ name 'Capture Left Mixer'					value Stereo				}
-			{ name 'Playback Mixer Voice Capture Sw'	value false					}
-			{ name 'Playback Mixer Left Capture Swi'	value false					}
-			{ name 'Playback Mixer Right Capture Sw'	value false					}
 			{ name 'Out4 Mux'							value VREF					}
 			{ name 'Out3 Mux'							value VREF					}
 			{ name 'Mono 2 Mux'							value 'Inverted Mono 1'		}
 			{ name 'Mono Mixer Left Playback Switch'	value false					}
-			{ name 'Mono Mixer Right Playback Switc'	value false					}
-			{ name 'Mono Mixer Voice Playback Switc'	value false					}
-			{ name 'Mono Mixer Sidetone Playback Sw'	value false					}
-			{ name 'Mono Mixer Bypass Playback Swit'	value false					}
-			{ name 'Right Mixer Voice Playback Swit'	value false					}
-			{ name 'Right Mixer Sidetone Playback S'	value false					}
-			{ name 'Right Mixer Right Playback Swit'	value true					}
-			{ name 'Right Mixer Bypass Playback Swi'	value false					}
-			{ name 'Left Mixer Voice Playback Switc'	value false					}
-			{ name 'Left Mixer Sidetone Playback Sw'	value false					}
 			{ name 'Left Mixer Left Playback Switch'	value true					}
-			{ name 'Left Mixer Bypass Playback Swit'	value false					}
 			{ name 'DAPM Stereo Out Switch'				value true					}
 			{ name 'DAPM GSM Line Out Switch'			value false					}
 			{ name 'DAPM GSM Line In Switch'			value false					}
@@ -537,25 +481,11 @@
 			{ name 'Capture Left Mux'					value PGA					}
 			{ name 'Capture Right Mixer'				value Stereo				}
 			{ name 'Capture Left Mixer'					value Stereo				}
-			{ name 'Playback Mixer Voice Capture Sw'	value false					}
-			{ name 'Playback Mixer Left Capture Swi'	value false					}
-			{ name 'Playback Mixer Right Capture Sw'	value false					}
 			{ name 'Out4 Mux'							value VREF					}
 			{ name 'Out3 Mux'							value VREF					}
 			{ name 'Mono 2 Mux'							value 'Inverted Mono 1'		}
 			{ name 'Mono Mixer Left Playback Switch'	value false					}
-			{ name 'Mono Mixer Right Playback Switc'	value false					}
-			{ name 'Mono Mixer Voice Playback Switc'	value false					}
-			{ name 'Mono Mixer Sidetone Playback Sw'	value true					}
-			{ name 'Mono Mixer Bypass Playback Swit'	value false					}
-			{ name 'Right Mixer Voice Playback Swit'	value false					}
-			{ name 'Right Mixer Sidetone Playback S'	value false					}
-			{ name 'Right Mixer Right Playback Swit'	value false					}
-			{ name 'Right Mixer Bypass Playback Swi'	value true					}
-			{ name 'Left Mixer Voice Playback Switc'	value false					}
-			{ name 'Left Mixer Sidetone Playback Sw'	value false					}
 			{ name 'Left Mixer Left Playback Switch'	value false					}
-			{ name 'Left Mixer Bypass Playback Swit'	value true					}
 			{ name 'DAPM Stereo Out Switch'				value false					}
 			{ name 'DAPM GSM Line Out Switch'			value true					}
 			{ name 'DAPM GSM Line In Switch'			value true					}
@@ -647,25 +577,11 @@
 			{ name 'Capture Left Mux'					value PGA					}
 			{ name 'Capture Right Mixer'				value Stereo				}
 			{ name 'Capture Left Mixer'					value Stereo				}
-			{ name 'Playback Mixer Voice Capture Sw'	value false					}
-			{ name 'Playback Mixer Left Capture Swi'	value false					}
-			{ name 'Playback Mixer Right Capture Sw'	value false					}
 			{ name 'Out4 Mux'							value VREF					}
 			{ name 'Out3 Mux'							value VREF					}
 			{ name 'Mono 2 Mux'							value 'Inverted Mono 1'		}
 			{ name 'Mono Mixer Left Playback Switch'	value false					}
-			{ name 'Mono Mixer Right Playback Switc'	value false					}
-			{ name 'Mono Mixer Voice Playback Switc'	value false					}
-			{ name 'Mono Mixer Sidetone Playback Sw'	value true					}
-			{ name 'Mono Mixer Bypass Playback Swit'	value false					}
-			{ name 'Right Mixer Voice Playback Swit'	value false					}
-			{ name 'Right Mixer Sidetone Playback S'	value false					}
-			{ name 'Right Mixer Right Playback Swit'	value false					}
-			{ name 'Right Mixer Bypass Playback Swi'	value true					}
-			{ name 'Left Mixer Voice Playback Switc'	value false					}
-			{ name 'Left Mixer Sidetone Playback Sw'	value false					}
 			{ name 'Left Mixer Left Playback Switch'	value false					}
-			{ name 'Left Mixer Bypass Playback Swit'	value true					}
 			{ name 'DAPM Stereo Out Switch'				value true					}
 			{ name 'DAPM GSM Line Out Switch'			value true					}
 			{ name 'DAPM GSM Line In Switch'			value true					}
@@ -757,25 +673,11 @@
 			{ name 'Capture Left Mux'					value PGA					}
 			{ name 'Capture Right Mixer'				value Stereo				}
 			{ name 'Capture Left Mixer'					value Stereo				}
-			{ name 'Playback Mixer Voice Capture Sw'	value false					}
-			{ name 'Playback Mixer Left Capture Swi'	value false					}
-			{ name 'Playback Mixer Right Capture Sw'	value false					}
 			{ name 'Out4 Mux'							value VREF					}
 			{ name 'Out3 Mux'							value VREF					}
 			{ name 'Mono 2 Mux'							value 'Inverted Mono 1'		}
 			{ name 'Mono Mixer Left Playback Switch'	value false					}
-			{ name 'Mono Mixer Right Playback Switc'	value false					}
-			{ name 'Mono Mixer Voice Playback Switc'	value false					}
-			{ name 'Mono Mixer Sidetone Playback Sw'	value true					}
-			{ name 'Mono Mixer Bypass Playback Swit'	value false					}
-			{ name 'Right Mixer Voice Playback Swit'	value false					}
-			{ name 'Right Mixer Sidetone Playback S'	value false					}
-			{ name 'Right Mixer Right Playback Swit'	value false					}
-			{ name 'Right Mixer Bypass Playback Swi'	value true					}
-			{ name 'Left Mixer Voice Playback Switc'	value false					}
-			{ name 'Left Mixer Sidetone Playback Sw'	value false					}
 			{ name 'Left Mixer Left Playback Switch'	value false					}
-			{ name 'Left Mixer Bypass Playback Swit'	value true					}
 			{ name 'DAPM Stereo Out Switch'				value false					}
 			{ name 'DAPM GSM Line Out Switch'			value true					}
 			{ name 'DAPM GSM Line In Switch'			value true					}
@@ -875,25 +777,11 @@
 			{ name 'Capture Left Mux'					value PGA					}
 			{ name 'Capture Right Mixer'				value 'Analogue Mix Left'	}
 			{ name 'Capture Left Mixer'					value 'Analogue Mix Left'	}
-			{ name 'Playback Mixer Voice Capture Sw'	value false					}
-			{ name 'Playback Mixer Left Capture Swi'	value false					}
-			{ name 'Playback Mixer Right Capture Sw'	value false					}
 			{ name 'Out4 Mux'							value VREF					}
 			{ name 'Out3 Mux'							value VREF					}
 			{ name 'Mono 2 Mux'							value 'Inverted Mono 1'		}
 			{ name 'Mono Mixer Left Playback Switch'	value false					}
-			{ name 'Mono Mixer Right Playback Switc'	value false					}
-			{ name 'Mono Mixer Voice Playback Switc'	value false					}
-			{ name 'Mono Mixer Sidetone Playback Sw'	value false					}
-			{ name 'Mono Mixer Bypass Playback Swit'	value false					}
-			{ name 'Right Mixer Voice Playback Swit'	value false					}
-			{ name 'Right Mixer Sidetone Playback S'	value false					}
-			{ name 'Right Mixer Right Playback Swit'	value false					}
-			{ name 'Right Mixer Bypass Playback Swi'	value false					}
-			{ name 'Left Mixer Voice Playback Switc'	value false					}
-			{ name 'Left Mixer Sidetone Playback Sw'	value false					}
 			{ name 'Left Mixer Left Playback Switch'	value false					}
-			{ name 'Left Mixer Bypass Playback Swit'	value false					}
 			{ name 'DAPM Stereo Out Switch'				value false					}
 			{ name 'DAPM GSM Line Out Switch'			value true					}
 			{ name 'DAPM GSM Line In Switch'			value true					}