From 2aeea757dc8ac787cee4f50f9c753bb7815b1d37 Mon Sep 17 00:00:00 2001
From: Yaroslav Halchenko <debian@onerussian.com>
Date: Mon, 21 Jun 2010 16:02:23 -0400
Subject: [PATCH 1/2] ENH: non-functional -- tabs, "Initi[t]ating" spelling

---
 src/phoneui-utils-calls.c    |    6 +++---
 src/phoneui-utils-contacts.c |    2 +-
 src/phoneui-utils-sound.c    |   42 +++++++++++++++++++++---------------------
 3 files changed, 25 insertions(+), 25 deletions(-)

diff --git a/src/phoneui-utils-calls.c b/src/phoneui-utils-calls.c
index 12833fd..12e8a5a 100644
--- a/src/phoneui-utils-calls.c
+++ b/src/phoneui-utils-calls.c
@@ -35,7 +35,7 @@ _call_initiate_callback(GObject *source, GAsyncResult *res, gpointer data)
 	int callid;
 	struct _call_pack *pack = data;
 
-        callid = free_smartphone_gsm_call_initiate_finish
+	callid = free_smartphone_gsm_call_initiate_finish
 					(pack->call, res, &error);
 	if (pack->callback) {
 		pack->callback(error, callid, pack->data);
@@ -54,7 +54,7 @@ phoneui_utils_call_initiate(const char *number,
 {
 	struct _call_pack *pack;
 
-	g_message("Inititating a call to %s\n", number);
+	g_message("Initiating a call to %s\n", number);
 	pack = malloc(sizeof(*pack));
 	pack->callback = callback;
 	pack->data = userdata;
@@ -251,7 +251,7 @@ phoneui_utils_ussd_initiate(const char *request,
 {
 	struct _network_pack *pack;
 
-	g_message("Inititating a USSD request %s\n", request);
+	g_message("Initiating a USSD request %s\n", request);
 	pack = malloc(sizeof(*pack));
 	pack->callback = callback;
 	pack->data = data;
diff --git a/src/phoneui-utils-contacts.c b/src/phoneui-utils-contacts.c
index e4563e8..fe6a5f5 100644
--- a/src/phoneui-utils-contacts.c
+++ b/src/phoneui-utils-contacts.c
@@ -346,7 +346,7 @@ _contact_lookup_callback(GObject *source, GAsyncResult *res, gpointer data)
 	g_debug("_contact_lookup_callback");
 	path = free_smartphone_pim_contacts_get_single_entry_single_field_finish
 					(pack->contacts, res, &error);
-        g_debug("got path %s", path);
+	g_debug("got path %s", path);
 	if (error || !path || !*path) {
 		pack->callback(error, NULL, pack->data);
 		if (error) {
diff --git a/src/phoneui-utils-sound.c b/src/phoneui-utils-sound.c
index 3c34794..4b08c60 100644
--- a/src/phoneui-utils-sound.c
+++ b/src/phoneui-utils-sound.c
@@ -556,13 +556,13 @@ phoneui_utils_sound_init(GKeyFile *keyfile)
 	int err, f;
 	char *device_name;
 	static GSourceFuncs funcs = {
-                _sourcefunc_prepare,
-                _sourcefunc_check,
-                _sourcefunc_dispatch,
-                0,
+		_sourcefunc_prepare,
+		_sourcefunc_check,
+		_sourcefunc_dispatch,
+		0,
 		0,
 		0
-        };
+	};
 
 
 	sound_state = SOUND_STATE_IDLE;
@@ -714,13 +714,13 @@ _phoneui_utils_sound_volume_changed_cb(snd_hctl_elem_t *elem, unsigned int mask)
 	int volume;
 
 
-        if (mask == SND_CTL_EVENT_MASK_REMOVE)
-                return 0;
-        if (mask & SND_CTL_EVENT_MASK_VALUE) {
-                snd_ctl_elem_value_alloca(&control);
-                snd_hctl_elem_read(elem, control);
-                type = _phoneui_utils_sound_volume_element_to_type(elem);
-                if (type != CONTROL_END) {
+	if (mask == SND_CTL_EVENT_MASK_REMOVE)
+		return 0;
+	if (mask & SND_CTL_EVENT_MASK_VALUE) {
+		snd_ctl_elem_value_alloca(&control);
+		snd_hctl_elem_read(elem, control);
+		type = _phoneui_utils_sound_volume_element_to_type(elem);
+		if (type != CONTROL_END) {
 			volume = phoneui_utils_sound_volume_get(type);
 			g_debug("Got alsa volume change for control '%s', new value: %d%%",
 				controls[STATE_INDEX][type].name, volume);
@@ -728,7 +728,7 @@ _phoneui_utils_sound_volume_changed_cb(snd_hctl_elem_t *elem, unsigned int mask)
 				_phoneui_utils_sound_volume_changed_callback(type, volume, _phoneui_utils_sound_volume_changed_userdata);
 			}
 		}
-        }
+	}
 	return 0;
 }
 
@@ -740,13 +740,13 @@ _phoneui_utils_sound_volume_mute_changed_cb(snd_hctl_elem_t *elem, unsigned int
 	int mute;
 
 
-        if (mask == SND_CTL_EVENT_MASK_REMOVE)
-                return 0;
-        if (mask & SND_CTL_EVENT_MASK_VALUE) {
-                snd_ctl_elem_value_alloca(&control);
-                snd_hctl_elem_read(elem, control);
-                type = _phoneui_utils_sound_volume_mute_element_to_type(elem);
-                if (type != CONTROL_END) {
+	if (mask == SND_CTL_EVENT_MASK_REMOVE)
+		return 0;
+	if (mask & SND_CTL_EVENT_MASK_VALUE) {
+		snd_ctl_elem_value_alloca(&control);
+		snd_hctl_elem_read(elem, control);
+		type = _phoneui_utils_sound_volume_mute_element_to_type(elem);
+		if (type != CONTROL_END) {
 			mute = phoneui_utils_sound_volume_mute_get(type);
 			g_debug("Got alsa mute change for control type '%d', new value: %d",
 				type, mute);
@@ -754,7 +754,7 @@ _phoneui_utils_sound_volume_mute_changed_cb(snd_hctl_elem_t *elem, unsigned int
 				_phoneui_utils_sound_volume_mute_changed_callback(type, mute, _phoneui_utils_sound_volume_mute_changed_userdata);
 			}
 		}
-        }
+	}
 	return 0;
 }
 int
-- 
1.7.1